<?php 
// +--------------------------------------------------------------------------+
// |   phpMyVisites   |   statistiques et mesure d'audience de sites Internet |
// +--------------------------------------------------------------------------+
// | Copyright (c) 2002-2004 Matthieu Aubry. Tous droits rservs             |
// +--------------------------------------------------------------------------+
// | Ce code est distribu sous license GNU GPL, disponible  '/docs/licence' |
// | Pour toute information supplmentaire :     							  |
// | http://www.phpmyvisites.net    |    matthieu@phpmyvisites.net            |
// +--------------------------------------------------------------------------+

/*----------------------------------------------*/
// fichier : functions_phpmv.php
/*----------------------------------------------*/

// fonction d'affichage de texte utile au dbugage
function printdebug($texte)
{
	if(DEBUG)
	{
		print($texte."<br>\n");
	}
}

function lang_navig($langue,$domaines)
{
	if(isset($langue))
	{
		// on utilise la langue du navigateur
		$lan = substr($langue,0,2);

		// si langue de la forme en-ca, en-gb... prendre les caractres 4-5
		if($lan == 'en' || $lan == 'sv')
		{
			$lan = substr($langue,3,2);
		}
		// on retourne langue du navig
		return $lan; 
	}
	else
	{
		// le pays est inconnu 
		return 	'xx';
	}
}

function get_pays($host,$langue,$domaines)
{
	// si il y a un host et qu'il n'est pas vide
	if(isset($host) && !empty($host))
	{
		// on le met ainsi que la langue du navig en miniscules
		$host = strtolower($host);
		$langue = strtolower($langue);
		// on prend l'extension (domain name) du host du visiteur
		ereg("\.([^.]+)$", $host, $cd);

		// et on regarde le pays dans le tableau domaines si il existe
		// si oui alors on le retourne
		// si non et langue du navig dfinie alors on la traite avec lang_navig
		// si non 'xx'

		// si le domain name du host est dfinie comme un pays
		if(isset($domaines["{$cd[1]}"]))
		{
			// p = nom du pays
			$p = $domaines["{$cd[1]}"];
			
			// si .com .net .org ou autres
			if($p == '-')
			{
				// traitement de la langue du navigateur
				return lang_navig($langue,$domaines);
			}
			// sinon on retourne le domain name car il correspond a un pays
			return $cd[1];
		}
		// si le domain name ne correspond pas  un pays rfrenc
		else
		{
			return lang_navig($langue,$domaines);
		}
	}
	// si il n'y a pas de host
	else
	{
		return lang_navig($langue,$domaines);
	}
}

function get_navig($agent)
{
	printdebug($agent);
	require_once("./include/navigateur.class.php");
	$navigateur_courant = new retrouver_navigateur();
	$navigateur_courant->initialisation();
	return strtoupper($navigateur_courant->_navigateur_info[strtolower('navigateur')]).";".$navigateur_courant->_navigateur_info[strtolower('version')];
}

// fonction inspire d'une fonction du script "Les Visiteurs" de J-Pierre Dzlus (jpdezelus_at_phpinfo_dot_net)
function get_os($agent,$lnav)
{
	for (@reset($lnav), $ok = false; (list($key, $value) = @each($lnav)) && !$ok;)
	{
		if ($ok = ereg($key, $agent))
		{
			return $value;
			break;
		}
	}
	return 'INC';
}

// on insre le suivi lors d'une visite dj reconnu
// sinon on insre pas car page1=page d'un autre site
function suivi($ref,$url)
{
	global $table_suivi;
	// si le referrer est bien dfini et non vide
	if(isset($ref) && !empty($ref))
	{
		// si l'ensemble page1 => page2 a dj t fait, alors on incrmente nb
		$req8 = mysql_query("UPDATE $table_suivi SET nb=nb+1 WHERE page1='$ref' AND page2='$url' AND date=CURRENT_DATE LIMIT 1");

		// sinon on insre son nom dans la bdd
		if(mysql_affected_rows()==0)
		{
			printdebug("<br><b>On insre le nouveau suivi $ref => $url dans la table</b>");
			$req9 = mysql_query("INSERT INTO $table_suivi (nb, page1, page2, date) VALUES (1, '$ref', '$url', CURRENT_DATE)");
		}
		else
		{
			printdebug("<br><b>Le suivi</b> $ref => $url <b>est connu</b>");
		}
	}
	else
	{
		printdebug("<br><b>Pas de referrer</b>");
	}
}

// on prend l'ip de la meilleure manire qu'il soit
function get_ip() 
{
	if (getenv("HTTP_CLIENT_IP"))
	{ 
		$ip = getenv("HTTP_CLIENT_IP"); 
	}
	elseif(getenv("HTTP_X_FORWARDED_FOR"))
	{ 
		$ip = getenv("HTTP_X_FORWARDED_FOR"); 
	}
	else 
	{ 
		$ip = getenv("REMOTE_ADDR"); 
	}
	return $ip;
}

// traitement de l'url en fonction des paramtres de configX.php
function params_get($url_paramsget)
{
	global $conditionsget;

	if(DEBUG)
	{
		printdebug("url avant traitement pour les paramtres GET : $url_paramsget");
	}
	// ? -> 
	for($i=0;$i<strlen($url_paramsget);$i++)
	{
		if($url_paramsget[$i]=='?')
		{
			if(isset($done1fois))
			{
				$url_paramsget[$i]='';
			}
			else
			{ 
				$done1fois=true; 
			} 
		}
	}
	// cas on on suprime tous les paramtres GET
	if ($conditionsget[0]) 
	{
		if (eregi("(.*)(\?)(.*)",$url_paramsget,$regs) ) $url_paramsget = $regs[1];
	} 
	else 
	{
		if (eregi("(.*)(\?phpsessid=)(.*)",$url_paramsget,$regs) ) $url_paramsget = $regs[1];
		if (eregi("(.*)(&phpsessid=)(.*)",$url_paramsget,$regs) ) $url_paramsget = $regs[1];
		if (isset($conditionsget))
		{
			// le array_search ne prenant pas en compte le premier element du tableau
			// on fait une manip en mettant un ;
			if (eregi("(.*)(\?)(.*)",$url_paramsget,$regs))
			{
				$url_paramsget = $regs[1];
				$paramsget = explode("&",$regs[3]);
				$lesgetinterdits = explode(";",";".$conditionsget[1]);
				$newquery_string = array();
				foreach($paramsget as $param) {
					$tabparam = explode("=",$param);
					if (!array_search($tabparam[0],$lesgetinterdits))
					{
						array_push($newquery_string,(isset($tabparam[1])?$tabparam[0]."=".$tabparam[1]:$tabparam[0]));
					}
				}
				$url_paramsget .= "?".implode("&",$newquery_string);
			}
		}
	}
	// si dernier caractre n'est pas  alors on le remplace
	if($url_paramsget[strlen($url_paramsget)-1] != '?')
	{	
		$url_paramsget=str_replace('','?',$url_paramsget);
	}
	// sinon on l'enlve car on prfre afficher page.php plutt que page.php?
	else
	{
		$url_paramsget = substr($url_paramsget,0, strlen($url_paramsget)-1);
	}	
	
	if(DEBUG) printdebug("url aprs traitement pour les paramtres GET : $url_paramsget<br>");

	return $url_paramsget;
}

// transforme url index en / pour les stats
function index_slash($url)
{
	if( $url==urldecode("/") || 
		$url==urldecode("/index") ||   
		$url==urldecode("/index.html") || 
		$url==urldecode("/index.htm") ||
		$url==urldecode("/index.php") ||
		$url==urldecode("/index.php3"))
		{
			printdebug("<br>URL DECODE<br>");
			$url='/';
		}
	return $url;
}

// si changements faire de mme dans functions_phpmv.php
// supprime les espaces dans les chaines (vs sql_injection)
function del_spaces($string)
{
	$string = str_replace(' ','',$string);
	return $string;
}

// si changements faire de mme dans functions.php
// test numeric
function testnum($string)
{
	if(!is_numeric($string)){ exit(); }
}

?>